#pragma once

#include "dtr.hpp"

namespace xlook
{
#if 0
enum Action { do_nothing = 0, do_strip_hobeta, do_extract };

struct DetectorResult
{
    int    structSize;//    
    Action action;//  
    DWORD  internal_id;//    extract  qview
    wchar_t   format[0x80];// assotiation  types.ini (    xTRD) ( xTRD sizeof(value)=128)
    wchar_t   title[50];//  
    wchar_t   ext[5];//       (  )
    HoHdr  hdr;//    ,   HRUST 1.x  2.2+
    wchar_t   comment[100];//    xTRD ( xTRD sizeof(comment)=100)
    WORD   noProcessedBytes;//    (   HoBeta)
};

typedef void (WINAPI *init_t)      (const wchar_t *path);
typedef bool (WINAPI *detect_t)    (DetectorResult& result, const wchar_t *file_name, const HoHdr *hdr, const BYTE *data, int data_size);
typedef bool (WINAPI *extract_t)   (HoHdr *hdr, const BYTE *source, DWORD sourceSize, BYTE *unpackBuffer, DWORD *noUnpackedBytes, DWORD internal_id);
//typedef bool (WINAPI *quickView_t) (HoHdr *hdr, const BYTE *source, DWORD sourceSize, BYTE *unpackBuffer, DWORD *noUnpackedBytes, DWORD internal_id);
typedef void (WINAPI *cleanup_t)   (void);
#endif

using init_t = decltype(init) *;
using detect_t = decltype(detect) *;
using extract_t = decltype(extract) *;
using cleanup_t = decltype(cleanup) *;

struct Detector
{
    HMODULE     handle;

    init_t init;
    detect_t detect;
    extract_t extract;
    //  quickView_t quickView;
    cleanup_t cleanup;
};

class DetectorManager
{
public:
    DetectorManager();
    ~DetectorManager();
    Detector* find(DetectorResult &result, const wchar_t *name, const BYTE *data, int file_size);

private:
    void LoadFolder(const wchar_t *path);
    int no_detectors;
    Detector detector[256]{};
};
}
