#ifndef MANAGER_HPP
#define MANAGER_HPP

class Manager
{
  public:
    Manager(const wchar_t* fileName);
    ~Manager();
    void GetOpenPanelInfo(struct OpenPanelInfo *Info);
    int  getFindData      (PluginPanelItem **pPanelItem, size_t *pNoItems, int opMode);
    void freeFindData     (PluginPanelItem *panelItem,   int  noItems);
    
    int  deleteFiles      (PluginPanelItem *panelItem, size_t noItems, int opMode);
    int  getFiles         (PluginPanelItem *panelItem, size_t noItems, int move, const wchar_t *destPath, int opMode);
    int  putFiles         (PluginPanelItem *panelItem, size_t noItems, int move, int opMode);
    int  processKey       (const INPUT_RECORD *Rec);
    
  private:
    bool readInfo         (void);
    void makePCNames      (void);
    bool openHostFile     (void);
    void closeHostFile    (void);
    
    bool deleteFilesImpl  (BYTE noItems);
    
    // action:                        return:
    //          0 -                      1 - ok/overwrite
    //          1 - overwriteAll                 0 - skip
    //          2 - skipAll                     -1 - cancel
    static int createFile        (HANDLE& file, const wchar_t* name, int& action);
    // hdrs -    
    // hdr  -   
    
    // action:                        return:
    //          0 -                      1 - write
    //          1 - writeAll                     0 - skip
    //          2 - skipAll                     -1 - cancel
    
    int checkExistingFiles(SCLHdr* hdrs, SCLHdr hdr, size_t no_files, int& allActions);

    //   
    DWORD copyFile         (int fileNum, HANDLE file, bool skipGarbage = false);
    
    wchar_t            hostFileName[300];
    HANDLE          hostFile;
    WIN32_FIND_DATAW lastModifed;
    bool            isReadOnly;
    
    BYTE       noFiles;
    SCLHdr     files[255];
    ExtFileHdr pcFiles[255];
};

#endif
